## mingw-w64-plplot-5.15.0-25.src.tar.zst

=== www/CMakeLists.txt ===
# www/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Configure documentation file sizes.
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/documentation.php.in
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php @ONLY
  )

# Configure style files
add_subdirectory(css)

# Set up Makefile rules to generate announcements and validate their DocBook-XML source.
add_subdirectory(announce)

# Copy base website files to a staging area in the build tree.

set(staging_FILES)

# Create the staging directory tree at cmake time.
file(MAKE_DIRECTORY
  ${CMAKE_CURRENT_BINARY_DIR}/staging/
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce
  )

# Note documentation.php configured as above.
set(toplevel_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/corefunctions.php
  ${CMAKE_CURRENT_SOURCE_DIR}/credits.php
  ${CMAKE_CURRENT_SOURCE_DIR}/development.php
  ${CMAKE_CURRENT_SOURCE_DIR}/downloads.php
  ${CMAKE_CURRENT_SOURCE_DIR}/examples.php
  ${CMAKE_CURRENT_SOURCE_DIR}/index.php
  ${CMAKE_CURRENT_SOURCE_DIR}/simplepie.inc
  ${CMAKE_CURRENT_BINARY_DIR}/documentation.php
  )

foreach(_file ${toplevel_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/${_filename}
    )
endforeach(_file ${toplevel_FILES})

# Note style files configure by CMake above in the css (build) directory.
set(css_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/css/closelabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/loading.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/nextlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/prevlabel.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/css/slimbox.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_liquid.css
  ${CMAKE_CURRENT_BINARY_DIR}/css/style_static.css
  )

foreach(_file ${css_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/css/${_filename}
    )
endforeach(_file ${css_FILES})

set(img_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/img/arrow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/content_bg.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/drop_shadow.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/header.jpg
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_hover_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/menu_selected_bg.gif
  ${CMAKE_CURRENT_SOURCE_DIR}/img/plplot_logo.jpg
  )

foreach(_file ${img_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/img/${_filename}
    )
endforeach(_file ${img_FILES})

set(js_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/js/slimbox.js
  )

foreach(_file ${js_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/js/${_filename}
    )
endforeach(_file ${js_FILES})

# The end of this list needs maintenance for each new release announcement
# that is generated (assuming we start making formal release announcements
# again).
set(announce_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.2.1-5.3.0
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.0-5.3.1
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/ChangeLog-5.3.1-5.3.2
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.1.0.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce-plplot-5.2.1.html
  ${CMAKE_CURRENT_SOURCE_DIR}/announce/announce.css
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.0.txt
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.xhtml
  ${CMAKE_CURRENT_BINARY_DIR}/announce/announce-plplot-5.3.1.txt
  )

# This has to be handled differently because some of these files created
# with the announce subdirectory generate_announcements target.
set(staging_announce_FILES)
foreach(_file ${announce_FILES})
  get_filename_component(_filename ${_file} NAME)
  add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  # Use cp -p to preserve dates/minimize rsync activity.
  COMMAND cp -p
  ${_file}
  ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
  DEPENDS ${_file}
  )
  list(APPEND staging_announce_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/announce/${_filename}
    )
endforeach(_file ${announce_FILES})

add_custom_target(
  create_staging_announce
  DEPENDS ${staging_announce_FILES}
  )
add_dependencies(create_staging_announce generate_announcements)

add_custom_target(
  create_staging
  DEPENDS ${staging_FILES}
  )
add_dependencies(create_staging create_staging_announce)

if(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)
  add_custom_target(
    www-install-base
    ssh ${WWW_USER}@${WWW_HOST} mkdir -p ${WWW_DIR}/htdocs
    COMMAND rsync -avq ${CMAKE_CURRENT_BINARY_DIR}/staging/htdocs/ ${WWW_USER}@${WWW_HOST}:${WWW_DIR}/htdocs
    )
  add_dependencies(www-install-base create_staging)
endif(DEFINED WWW_USER AND DEFINED WWW_HOST AND DEFINED WWW_DIR)

=== bindings/lua/CMakeLists.txt ===
# bindings/lua/CMakeLists.txt
# Copyright (C) 2008 Werner Smekal
# Copyright (C) 2017-2019 Alan W. Irwin

#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(ENABLE_lua)

  # This is currently the include list for swig.
  set(lua_interface_INCLUDE_PATHS
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/lib/qsastime
    ${CMAKE_CURRENT_BINARY_DIR}
    ${LUA_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}/bindings/swig-support
    )
  include_directories(${lua_interface_INCLUDE_PATHS})

  set(CMAKE_SWIG_FLAGS -DSWIG_LUA -module ${WRITEABLE_TARGET}plplotluac)
  set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

  set_source_files_properties(plplotluac.i
    PROPERTIES SWIG_MODULE_NAME plplotluac
    )

  set(SWIG_MODULE_plplotluac_EXTRA_DEPS
    ${CMAKE_SOURCE_DIR}/bindings/swig-support/plplotcapi.i)

  configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/lua_namespace.i.in
  ${CMAKE_CURRENT_BINARY_DIR}/lua_namespace.i
  @ONLY
  )

  # plplotluac depends on the plplot library.
  set(LIB_INSTALL_RPATH ${LIB_DIR})

  # Configure build of swig-generated C wrapper.
  configure_library_build(plplotluac lua plplotluac.i "PLPLOT::plplot;${LUA_LIBRARIES}" "${LIB_INSTALL_RPATH}" ${LUA_DIR})

endif(ENABLE_lua)

=== bindings/tk-x-plat/CMakeLists.txt ===
# bindings/tk-x-plat/CMakeLists.txt
# Copyright (C) 2006-2018 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

if(PLD_tkwin)

  if(USE_DLL_SUBDIRECTORY)
    set(LIB_INSTALL_DIR ${BIN_DIR})
  else(USE_DLL_SUBDIRECTORY)
    set(LIB_INSTALL_DIR ${DRV_DIR})
  endif(USE_DLL_SUBDIRECTORY)

  if(tcltk_in_plplot_library)
    set(DLNAME_LIBRARY_DIR $<TARGET_FILE_DIR:PLPLOT::plplot>)
    set(DLNAME_LIBRARY $<TARGET_FILE_NAME:PLPLOT::plplot>)
  else(tcltk_in_plplot_library)
    set(DLNAME_LIBRARY_DIR $<TARGET_FILE_DIR:PLPLOT::tkwin>)
    set(DLNAME_LIBRARY $<TARGET_FILE_NAME:PLPLOT::tkwin>)
  endif(tcltk_in_plplot_library)

  # N.B. Results only available at generate time.
  configure_file_generate(
    ${CMAKE_CURRENT_SOURCE_DIR}/pkgIndex.tcl.in
    ${CMAKE_CURRENT_BINARY_DIR}/pkgIndex.tcl
    @ONLY
    )

endif(PLD_tkwin)

=== www/announce/CMakeLists.txt ===
# www/announce/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2008-2018 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Create rules to generate announcments that are in DocBook-XML form.

set(URL http://plplot.org)
set(XML_DCL /usr/share/sgml/declaration/xml.dcl)
set(PWD "${CMAKE_BINARY_DIR}/www")


set(generated_RELEASE_LIST
  5.3.0
  5.3.1
  )

set(generated_announcements_target_LIST)
set(validation_target_LIST)
foreach(generated_RELEASE ${generated_RELEASE_LIST})
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.html
    COMMAND xmlto -m ${CMAKE_CURRENT_SOURCE_DIR}/html.xsl xhtml-nochunks ${CMAKE_CURRENT_SOURCE_DIR}/announce-plplot-${generated_RELEASE}.xml
    DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/html.xsl
    ${CMAKE_CURRENT_SOURCE_DIR}/announce-plplot-${generated_RELEASE}.xml
    )

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.xhtml
    COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.html
    ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.xhtml
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.html
    )

  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.txt
    COMMAND lynx -force_html -dump -width=80 ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.xhtml | sed \"s,file://localhost${PWD},${URL},\" > ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.txt
    DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.xhtml
    )
  list(
    APPEND generated_announcements_target_LIST
    ${CMAKE_CURRENT_BINARY_DIR}/announce-plplot-${generated_RELEASE}.txt
    )

  add_custom_target(
    validate_announcement-${generated_RELEASE}
    COMMAND onsgmls ${XML_DCL} ${CMAKE_CURRENT_SOURCE_DIR}/announce-plplot-${generated_RELEASE}.xml > /dev/null
    )
  list(
    APPEND
    validation_target_LIST
    validate_announcement-${generated_RELEASE}
    )

endforeach(generated_RELEASE ${generated_RELEASE_LIST})

add_custom_target(
  generate_announcements
  DEPENDS ${generated_announcements_target_LIST}
  )

add_custom_target(validate_announcements)
add_dependencies(validate_announcements ${validation_target_LIST})

=== www/css/CMakeLists.txt ===
# www/css/CMakeLists.txt to help generate the PLplot project website.

# Copyright (C) 2008-2018 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# Variables to control configuration of CSS files.

# Colour scheme for menu section is mostly done by fixed gradient
# background images.  Thus configuring the non-menu colours is tricky since
# the result must be reasonably consistent with menu.  Because of this
# limitation I (AWI) ultimately decided to configure just one colour
# (the dark text colour).

# Make dark text absolutely black for best visibility.
set(dark_text_color "#000000")

# Widths and heights:

# N.B. all configured widths and heights are expressed in percentages
# appropriate for the liquid style sheet.  To convert to static style sheet
# numbers simply multiply all these numbers primarily by 800/100 but
# sometimes by other factors when percentages are nested.
set(per_cent_width_pagewrapper 95)
set(per_cent_width_rightside 23)
set(per_cent_width_fullside 100)
set(per_cent_width_leftside 75)
set(per_cent_width_featurebox 31)
set(per_cent_height_pagefooter 8)
set(per_cent_width_codebox 92)
set(per_cent_width_searchbar 14)

# Liquid style:
set(width_pagewrapper "${per_cent_width_pagewrapper}%")
set(width_rightside "${per_cent_width_rightside}%")
set(width_fullside "${per_cent_width_fullside}%")
set(width_leftside "${per_cent_width_leftside}%")
set(width_featurebox "${per_cent_width_featurebox}%")
set(height_pagefooter "${per_cent_height_pagefooter}%")
set(width_codebox "${per_cent_width_codebox}%")
set(width_searchbar "${per_cent_width_searchbar}%")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/style.css.in
  ${CMAKE_CURRENT_BINARY_DIR}/style_liquid.css @ONLY
  )

# static style:
math(EXPR static_width_pagewrapper "${per_cent_width_pagewrapper}*(800/100)")
math(EXPR static_width_rightside "${per_cent_width_rightside}*(700/100)")
math(EXPR static_width_fullside "${per_cent_width_fullside}*(700/100)")
math(EXPR static_width_leftside "${per_cent_width_leftside}*(700/100)")
math(EXPR static_width_featurebox "${per_cent_width_featurebox}*(800/100)")
math(EXPR static_height_pagefooter "${per_cent_height_pagefooter}*(800/100)")
math(EXPR static_width_codebox "${per_cent_width_codebox}*(700/100)")
math(EXPR static_width_searchbar "${per_cent_width_searchbar}*(800/100)")

set(width_pagewrapper "${static_width_pagewrapper}px")
set(width_rightside "${static_width_rightside}px")
set(width_fullside "${static_width_fullside}px")
set(width_leftside "${static_width_leftside}px")
set(width_featurebox "${static_width_featurebox}px")
set(height_pagefooter "${static_height_pagefooter}px")
set(width_codebox "${static_width_codebox}px")
set(width_searchbar "${static_width_searchbar}px")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/style.css.in
  ${CMAKE_CURRENT_BINARY_DIR}/style_static.css @ONLY
  )

=== cmake/epa_build/cairo/CMakeLists.txt ===
# cairo/CMakeLists.txt

# Configure the build of cairo.

# N.B. this file is generated so if you edit it you will lose all your
# changes the next time it is generated (typically by running
# either/both the update_added_packages.sh or update_pango_packages.sh
# scripts).  If those scripts do not provide good results, then
# consider changing their source files (e.g., by editing the files
# used in those scripts) or add a patch to be run by those scripts.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE cairo)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST pkg-config;bison;flex;python2-devel;libX11;libXft;xorg-kbproto;xorg-macros;xorg-xproto;dbus ${extra_ignored_dependencies_list})

set(dependencies_LIST fontconfig;glib;gtk-doc;pixman;pkg-config)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  )

if(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
else(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
endif(MSYS_PLATFORM)

set(CXXFLAGS "$ENV{CXXFLAGS}")

# Drop -fvisibility=hidden since that option does not work for a
# number of software packages that are configured automatically using
# this template.
string(REGEX REPLACE "-fvisibility=hidden" "" CFLAGS "${CFLAGS}")
string(REGEX REPLACE "-fvisibility=hidden" "" CXXFLAGS "${CXXFLAGS}")

# Data that is related to downloads.
set(URL http://cairographics.org/releases/cairo-1.12.14.tar.xz)
set(DOWNLOAD_HASH_TYPE SHA256)
set(DOWNLOAD_HASH 96d0d1e3f9b74d2ca3469ff187c5e5f25649b1ad35cf06f4f3a83847dff4ac13)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" "CXXFLAGS=${CXXFLAGS}" ${source_PATH}/${EPA_CONFIGURE_COMMAND} --enable-xlib
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}
  BUILD_IN_SOURCE OFF
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}  install
  )

=== cmake/epa_build/libqhull/CMakeLists.txt ===
# libqhull/CMakeLists.txt

# Configure the build of libqhull.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE libqhull)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST ${extra_ignored_dependencies_list})

set(dependencies_LIST)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  )

set(CFLAGS "$ENV{CFLAGS}")

# Data that is related to downloads.
set(URL http://www.qhull.org/download/qhull-2010.1-src.tgz)
set(URL_MD5 e64138470acdeb18f752a0bc2a11ceb4)

ExternalProject_Add(
  build_${PACKAGE}
  URL ${URL}
  URL_MD5 ${URL_MD5}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" ${EPA_CMAKE_COMMAND} ${EPA_BASE}/Source/build_${PACKAGE}
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND}
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND} install
  )

# Add custom commands to the current no-command update step.
add_custom_command(
  OUTPUT
  ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-update
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}_CMakeLists.txt
  ${EPA_BASE}/Source/build_${PACKAGE}/CMakeLists.txt
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_SOURCE_DIR}/src/CMakeLists.txt
  ${EPA_BASE}/Source/build_${PACKAGE}/src/CMakeLists.txt
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_SOURCE_DIR}/src/${PACKAGE}.h
  ${EPA_BASE}/Source/build_${PACKAGE}/src/${PACKAGE}.h
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_SOURCE_DIR}/src/mem.h
  ${EPA_BASE}/Source/build_${PACKAGE}/src/mem.h
  COMMAND ${CMAKE_COMMAND} -E copy
  ${CMAKE_CURRENT_SOURCE_DIR}/src/unix.c
  ${EPA_BASE}/Source/build_${PACKAGE}/src/unix.c
  COMMENT "Custom updating of ${PACKAGE}"
  DEPENDS
  ${CMAKE_CURRENT_SOURCE_DIR}/${PACKAGE}_CMakeLists.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/src/CMakeLists.txt
  ${CMAKE_CURRENT_SOURCE_DIR}/src/${PACKAGE}.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/mem.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/unix.c
  APPEND
  )

=== cmake/epa_build/pango/CMakeLists.txt ===
# pango/CMakeLists.txt

# Configure the build of pango.

# N.B. this file is generated so if you edit it you will lose all your
# changes the next time it is generated (typically by running
# either/both the update_added_packages.sh or update_pango_packages.sh
# scripts).  If those scripts do not provide good results, then
# consider changing their source files (e.g., by editing the files
# used in those scripts) or add a patch to be run by those scripts.

# Copyright (C) 2013 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE pango)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST pkg-config;bison;flex;python2-devel;libX11;libXft;xorg-kbproto;xorg-macros;xorg-xproto;dbus ${extra_ignored_dependencies_list})

set(dependencies_LIST cairo;fontconfig;glib;gobject-introspection;gtk-doc;harfbuzz;libXft)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  )

if(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
else(MSYS_PLATFORM)
  set(CFLAGS "$ENV{CFLAGS}")
endif(MSYS_PLATFORM)

set(CXXFLAGS "$ENV{CXXFLAGS}")

# Drop -fvisibility=hidden since that option does not work for a
# number of software packages that are configured automatically using
# this template.
string(REGEX REPLACE "-fvisibility=hidden" "" CFLAGS "${CFLAGS}")
string(REGEX REPLACE "-fvisibility=hidden" "" CXXFLAGS "${CXXFLAGS}")

# Data that is related to downloads.
set(URL http://download.gnome.org/sources/pango/1.35/pango-1.35.0.tar.xz)
set(DOWNLOAD_HASH_TYPE SHA256)
set(DOWNLOAD_HASH c21f7277b5c088f334748b38f2c3abd6399024d653ab7663f567234acbdc7f92)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS ${dependencies_targets}
  URL ${URL}
  URL_HASH ${DOWNLOAD_HASH_TYPE}=${DOWNLOAD_HASH}
  CONFIGURE_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" "CXXFLAGS=${CXXFLAGS}" ${source_PATH}/${EPA_CONFIGURE_COMMAND} --with-cairo --enable-installed-tests
  BUILD_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}
  BUILD_IN_SOURCE OFF
  INSTALL_COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_MAKE_COMMAND}  install
  )

=== cmake/epa_build/plplot_lite/CMakeLists.txt ===
# plplot_lite/CMakeLists.txt

# Configure the build of a "lite" version of PLplot (with fewer dependencies
# but with fewer features as well).

# Copyright (C) 2013-2015 Alan W. Irwin

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this file; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(PACKAGE plplot_lite)

# List of dependencies (most of which are build tools) which should be
# ignored.
set(ignored_dependencies_LIST ${extra_ignored_dependencies_list})

set(dependencies_LIST
  # agg website now (2014-04-13) a broken link, and this library only
  # needed in any case for a purpose that may disappear (wxwidgets).
  # So drop it.
  #libagg
  libharu
  libqhull
  shapelib
  #wxwidgets
  )

# For now only add in these dependencies for the Unix case because
# these epa_builds do not yet work on Windows.

if(NOT MSYS_PLATFORM)
  list(APPEND dependencies_LIST
    #pango
    #qt5_lite
    #libLASi
    octave_lite
    )
endif(NOT MSYS_PLATFORM)

# Do boilerplate tasks that must be done for each different project
# that is configured as part of epa_build.
epa_boilerplate(
  ignored_dependencies_LIST
  PACKAGE
  dependencies_LIST
  dependencies_targets
  EPA_PATH
  source_PATH
  )

set(CFLAGS "$ENV{CFLAGS}")
set(CXXFLAGS "$ENV{CXXFLAGS}")
set(FFLAGS "$ENV{FFLAGS}")

set(cmake_args)

# Drop gtk+2-only dependencies since those clash (at build time for static
# device drivers and at run-time with dynamic device drivers) with
# gtk+3 that is used with epa_build.
list(APPEND cmake_args
  -DDROP_GTK_PLUS_2_BUILDS=ON
  )

# In addition turn off psttf (which depends on libLASi), wxwidgets, cairo, and qt for plplot_lite.
list(APPEND cmake_args
  -DPLD_psttf=OFF
  -DPLD_wxwidgets=OFF
  -DENABLE_wxwidgets=OFF
  -DDEFAULT_NO_CAIRO_DEVICES:BOOL=ON
  -DDEFAULT_NO_QT_DEVICES:BOOL=ON
  -DENABLE_qt=OFF
  # Also turn off simple testing of dynamically loaded devices
  # because on Windows sometimes the simple test fails (in the
  # sense of giving the correct result while generating a
  # non-zero return code for unknown reasons) but the
  # actual dynload done by the PLplot library succeeds for some reason.
  -DTEST_DYNDRIVERS=OFF
  )

# Assumption that the top-level local PLplot source tree is two directories
# up from the present top-level directory for epa_build.
# This assumption is correct if you are accessing epa_build as
# a subset of the PLplot source tree so that its location is in
# cmake/epa_build within that source tree.
# But it is not the case if you have independently
# checked out just the epa_build subset of the normal PLplot source
# tree so check that the result really is a plplot source tree.
get_filename_component(PLPLOT_LOCAL_SOURCE_DIR ${CMAKE_SOURCE_DIR} PATH)
get_filename_component(PLPLOT_LOCAL_SOURCE_DIR ${PLPLOT_LOCAL_SOURCE_DIR} PATH)
find_file(IS_PLPLOT_SOURCE_TREE plcore.c
  HINTS ${PLPLOT_LOCAL_SOURCE_DIR}/src
  NO_DEFAULT_PATH
  )

if(NOT IS_PLPLOT_SOURCE_TREE)
  message(FATAL_ERROR "epa_build not located in cmake/epa_build in a PLplot source tree")
endif(NOT IS_PLPLOT_SOURCE_TREE)

# Data that is related to the PATH that must be used.
if(MSYS_PLATFORM)
  set(EPA_PATH_NODLL "${EPA_PATH}")
  set(EPA_PATH "${EPA_BASE}/Build/build_${PACKAGE}/dll;${EPA_PATH_NODLL}")
  determine_msys_path(EPA_PATH "${EPA_PATH}")
endif(MSYS_PLATFORM)

ExternalProject_Add(
  build_${PACKAGE}
  DEPENDS "${dependencies_targets}"
  DOWNLOAD_COMMAND ${CMAKE_COMMAND} -E copy_directory ${PLPLOT_LOCAL_SOURCE_DIR} ${EPA_BASE}/Source/build_${PACKAGE}
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  TEST_BEFORE_INSTALL OFF
  TEST_COMMAND ""
  STEP_TARGETS configure build install test
  )

if(COMPREHENSIVE_PLPLOT_TEST_INTERACTIVE OR COMPREHENSIVE_PLPLOT_TEST_NONINTERACTIVE)
  string(REGEX REPLACE ";" " " blank_delimited_cmake_args "${cmake_args}")

  if(COMPREHENSIVE_PLPLOT_TEST_INTERACTIVE)
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/interactive_comprehensive_test.sh
      "echo yes | ${EPA_BASE}/Source/build_${PACKAGE}/scripts/comprehensive_test.sh --generator_string \"${CMAKE_GENERATOR}\" --cmake_added_options \"${blank_delimited_cmake_args}\" --build_command \"${EPA_BUILD_COMMAND} -j${NUMBER_PARALLEL_JOBS}\" --ctest_command \"${CMAKE_CTEST_COMMAND} -j${NUMBER_PARALLEL_JOBS} --timeout 15000 \" --do_ctest no --do_test_noninteractive no"
      )

    add_custom_command(
      OUTPUT
      ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-test
      COMMAND ${CMAKE_COMMAND} -E echo "comprehensive interactive tests"
      COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${BASH_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/interactive_comprehensive_test.sh
      APPEND
      )
  endif(COMPREHENSIVE_PLPLOT_TEST_INTERACTIVE)

  if(COMPREHENSIVE_PLPLOT_TEST_NONINTERACTIVE)
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/noninteractive_comprehensive_test.sh
      "echo yes | ${EPA_BASE}/Source/build_${PACKAGE}/scripts/comprehensive_test.sh --generator_string \"${CMAKE_GENERATOR}\" --cmake_added_options \"${blank_delimited_cmake_args}\" --build_command \"${EPA_BUILD_COMMAND} -j${NUMBER_PARALLEL_JOBS}\" --ctest_command \"${CMAKE_CTEST_COMMAND} -j${NUMBER_PARALLEL_JOBS} --timeout 15000 \" --do_test_interactive no"
      )

    add_custom_command(
      OUTPUT
      ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-test
      COMMAND ${CMAKE_COMMAND} -E echo "comprehensive noninteractive tests"
      COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${BASH_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/noninteractive_comprehensive_test.sh
      APPEND
      )
  endif(COMPREHENSIVE_PLPLOT_TEST_NONINTERACTIVE)
else(COMPREHENSIVE_PLPLOT_TEST_INTERACTIVE OR COMPREHENSIVE_PLPLOT_TEST_NONINTERACTIVE)

  # If ENABLE_COMPREHENSIVE_PLPLOT_TEST is not true, then just
  # configure a pure default case and build and install it.

  add_custom_command(
    OUTPUT
    ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-configure
    COMMAND ${CMAKE_COMMAND} -E echo "configure"
    COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} "CFLAGS=${CFLAGS}" "CXXFLAGS=${CXXFLAGS}" "FFLAGS=${FFLAGS}" ${EPA_CMAKE_COMMAND} -DBUILD_TEST=ON ${cmake_args} ${EPA_BASE}/Source/build_${PACKAGE}
    APPEND
    )

  add_custom_command(
    OUTPUT
    ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-build
    COMMAND ${CMAKE_COMMAND} -E echo "build"
    COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND}
    APPEND
    )

  add_custom_command(
    OUTPUT
    ${EPA_BASE}/Stamp/build_${PACKAGE}/build_${PACKAGE}-install
    COMMAND ${CMAKE_COMMAND} -E echo "install"
    COMMAND ${ENV_EXECUTABLE} PATH=${EPA_PATH} ${EPA_PARALLEL_BUILD_COMMAND} install
    APPEND
    )

endif(COMPREHENSIVE_PLPLOT_TEST_INTERACTIVE OR COMPREHENSIVE_PLPLOT_TEST_NONINTERACTIVE)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Jürgen Pfeifer <juergen@familiepfeifer.de>
# Contributor: Tim S. <stahta01@gmail.com>

# Note: Added "ENABLE_itk=OFF" because of random build errors;
# It appeared to think it found the itk library; but, it then errored out.
# Set "ENABLE_qt=OFF" and "DEFAULT_NO_CAIRO_DEVICES=ON" to reduce warnings.
# Had to define PLD_png and etc to ON to get libGD to be searched.

_wx_basever=3.2

_realname=plplot
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.15.0
pkgrel=25
pkgdesc="Scientific plotting software (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://plplot.sourceforge.io/"
license=('spdx:LGPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cairo"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-libgd"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-lua"
         "${MINGW_PACKAGE_PREFIX}-pango"
         #"${MINGW_PACKAGE_PREFIX}-python"
         #"${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-shapelib"
         "${MINGW_PACKAGE_PREFIX}-tk"
         "${MINGW_PACKAGE_PREFIX}-wxwidgets${_wx_basever}-msw-libs"
         "${MINGW_PACKAGE_PREFIX}-qhull"
        )
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-libgd"
             "${MINGW_PACKAGE_PREFIX}-fc"
             #"${MINGW_PACKAGE_PREFIX}-gcc-ada"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-wxwidgets${_wx_basever}-msw")
optdepends=("${MINGW_PACKAGE_PREFIX}-swig: connects Plplot C library to Python and Lua")
source=(https://downloads.sourceforge.net/sourceforge/plplot/${_realname}-${pkgver}.tar.gz
        find-gd.patch
        Include-wx-msw-wrapwin.h-instead-of-Windows.h.patch
        pdf-linking-libharu.patch
        fix-pkgconfig.patch
        fix-install-dir.patch
        fix-cmake-path-relocation.patch
        fix-wingdi.patch
        include-qpainterpath.patch)
sha256sums=('b92de4d8f626a9b20c84fc94f4f6a9976edd76e33fb1eae44f6804bdcc628c7b'
            '57ad3a43d5ad467b89889a42d0b033e35cf322b9b83f2f41a62fe5d74a5d01b8'
            'fc27681c6ca521308ac0d873b3ed78c335e676ca6d367fd8d000a41580565ed8'
            'abf5ee33dad2108220d0973de4279ce04007b9fb429184d194a6cf951005c8be'
            '4bbd508fbd83fcdbce779216a224b15fac55d92c9bb66d66d1d95c4eac1d1322'
            'c11a37adea8134f9497fd45f24cd153cce18855ddff66ea5ba6ef8875da022fc'
            'a79ce95cc2dc0a4eade6f5f68b3f7d6cd335f0fc8fcb18bb69468ea4ef6b6ab2'
            '675b7bdf421a81ba390b023dc94a0d43604180fa60a88364c6883fb02a950acc'
            '8d5d647042b5ae51043bd48589622a85c807785287a1024b75d4fcb7ab7da22e')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${srcdir}/${_realname}-${pkgver}

  apply_patch_with_msg \
    find-gd.patch \
    Include-wx-msw-wrapwin.h-instead-of-Windows.h.patch \
    pdf-linking-libharu.patch \
    fix-pkgconfig.patch \
    fix-install-dir.patch \
    fix-cmake-path-relocation.patch \
    fix-wingdi.patch \
    include-qpainterpath.patch
}

build() {
  mkdir -p ${srcdir}/build-${MSYSTEM} && cd ${srcdir}/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # cmake may be confused if there is a Windows installation
  # of the official Python MSI. Please do the Python-enabled
  # build only, if no official Python is installed.
  local pyexe="${MINGW_PREFIX}/bin/python3.exe"
  local pyver=$(${pyexe} -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")
  local pylib="${MINGW_PREFIX}/lib/libpython${pyver}.dll.a"
  if [[ ${pyver:0:1} != "3" ]] ; then
     pylib="${MINGW_PREFIX}/lib/libpython${pyver}m.dll.a"
  fi

  CFLAGS+=" -Wno-incompatible-pointer-types -Wno-implicit-function-declaration -Wno-int-conversion" \
  CXXFLAGS+=" -Wno-deprecated-declarations -Wno-ignored-attributes" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_TEST=OFF \
    -DPYTHON_VERSION=${pyver} \
    -DPYTHON_EXECUTABLE=${pyexe} \
    -DPYTHON_LIBRARY=${pylib} \
    -DPYTHON_INCLUDE_DIRS=${MINGW_PREFIX}/include/python${pyver} \
    -DQHULL_INCLUDE_DIRS=${MINGW_PREFIX}/include \
    -DQHULL_LIBRARY_DIRS=${MINGW_PREFIX}/lib \
    -DQHULL_LIBRARIES=qhullstatic \
    -DGD_INCLUDE_DIR=${MINGW_PREFIX}/include \
    -DwxWidgets_CONFIG_EXECUTABLE=${MINGW_PREFIX}/bin/wx-config-${_wx_basever} \
    -DDEFAULT_NO_BINDINGS=ON \
    -DENABLE_ada=OFF \
    -DENABLE_cxx=ON \
    -DENABLE_fortran=ON \
    -DENABLE_lua=ON \
    -DENABLE_python=OFF \
    -DENABLE_tcl=ON \
    -DENABLE_tk=ON \
    -DENABLE_DYNDRIVERS=OFF \
    -DENABLE_wxwidgets=ON \
    -DENABLE_itk=OFF \
    -DENABLE_qt=ON \
    -DPLD_png=ON \
    -DPLD_jpeg=ON \
    -DPLD_gif=ON \
    -DPLD_wingcc=ON \
    -DPLD_wingdi=ON \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  local MINGW_PREFIX_WIN=$(cygpath -am ${MINGW_PREFIX})
  local MSYS2_USR_WIN=$(cygpath -am /usr)

  # Fix paths in pkgconfig files (#17541)
  find "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig" -type f -name '*.pc' \
    -exec sed -i -e "s|${MINGW_PREFIX_WIN}|${MINGW_PREFIX}|g" \
    -e "s|${MINGW_PREFIX}/include|\${prefix}/include|g" \
    -e "s|${MINGW_PREFIX}/lib|\${prefix}/lib|g" {} \;

  # Fix paths in cmake files
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/${_realname}/*.cmake; do
    sed -e "s|${MINGW_PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Fix paths in example files
  find "${pkgdir}${MINGW_PREFIX}/share/plplot${pkgver}/examples" -type f -name '*.sh' \
    -exec sed -i -e "s|${MINGW_PREFIX_WIN}|${MINGW_PREFIX}|g" {} \;
  find "${pkgdir}${MINGW_PREFIX}/share/plplot${pkgver}/examples" -type f -name 'Makefile' \
    -exec sed -i -e "s|${MINGW_PREFIX_WIN}|${MINGW_PREFIX}|g" {} \;
  find "${pkgdir}${MINGW_PREFIX}/share/plplot${pkgver}/examples" -type f -name '*.sh' \
    -exec sed -i -e "s|${MSYS2_USR_WIN}|/usr|g" {} \;
  find "${pkgdir}${MINGW_PREFIX}/share/plplot${pkgver}/examples" -type f -name 'Makefile' \
    -exec sed -i -e "s|${MSYS2_USR_WIN}|/usr|g" {} \;

  # Fix paths in the remaing odd files
  sed -s "s|${MINGW_PREFIX_WIN}|\${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tcl/tclsh_standard_examples
  sed -s "s|${MINGW_PREFIX_WIN}|\${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/wish_runAllDemos
  sed -s "s|${MINGW_PREFIX_WIN}|\${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/wish_standard_examples
  sed -s "s|${MINGW_PREFIX_WIN}|\${MINGW_PREFIX}|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/cmake/modules/plplot_configure.cmake
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/cmake/modules/plplot_configure.cmake
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tcl/pltcl_standard_examples
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tcl/tclsh_standard_examples
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/plserver_runAllDemos
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/plserver_standard_examples
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/wish_runAllDemos
  sed -s "s|${MSYS2_USR_WIN}|/usr|g" -i "${pkgdir}"${MINGW_PREFIX}/share/plplot${pkgver}/examples/tk/wish_standard_examples

  mkdir -p ${pkgdir}${MINGW_PREFIX}/share/licenses/$_realname
  cp -pf ${srcdir}/${_realname}-${pkgver}/Copyright \
    ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}
  cp -pf ${srcdir}/${_realname}-${pkgver}/COPYING* \
    ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}
}
